// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/iam/v3/principal_access_boundary_policies_service.proto

#include "google/cloud/iam/v3/internal/principal_access_boundary_policies_option_defaults.h"
#include "google/cloud/iam/v3/principal_access_boundary_policies_connection.h"
#include "google/cloud/iam/v3/principal_access_boundary_policies_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace iam_v3_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options PrincipalAccessBoundaryPoliciesDefaultOptions(Options options) {
  options = internal::PopulateCommonOptions(
      std::move(options),
      "GOOGLE_CLOUD_CPP_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_AUTHORITY",
      "iam.googleapis.com");
  options = internal::PopulateGrpcOptions(std::move(options));
  if (!options
           .has<iam_v3::PrincipalAccessBoundaryPoliciesRetryPolicyOption>()) {
    options.set<iam_v3::PrincipalAccessBoundaryPoliciesRetryPolicyOption>(
        iam_v3::PrincipalAccessBoundaryPoliciesLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options
           .has<iam_v3::PrincipalAccessBoundaryPoliciesBackoffPolicyOption>()) {
    options.set<iam_v3::PrincipalAccessBoundaryPoliciesBackoffPolicyOption>(
        ExponentialBackoffPolicy(
            std::chrono::seconds(0), std::chrono::seconds(1),
            std::chrono::minutes(5), kBackoffScaling, kBackoffScaling)
            .clone());
  }
  if (!options
           .has<iam_v3::PrincipalAccessBoundaryPoliciesPollingPolicyOption>()) {
    options.set<iam_v3::PrincipalAccessBoundaryPoliciesPollingPolicyOption>(
        GenericPollingPolicy<
            iam_v3::PrincipalAccessBoundaryPoliciesRetryPolicyOption::Type,
            iam_v3::PrincipalAccessBoundaryPoliciesBackoffPolicyOption::Type>(
            options
                .get<iam_v3::PrincipalAccessBoundaryPoliciesRetryPolicyOption>()
                ->clone(),
            ExponentialBackoffPolicy(std::chrono::seconds(1),
                                     std::chrono::minutes(5), kBackoffScaling)
                .clone())
            .clone());
  }
  if (!options.has<
          iam_v3::
              PrincipalAccessBoundaryPoliciesConnectionIdempotencyPolicyOption>()) {
    options.set<
        iam_v3::
            PrincipalAccessBoundaryPoliciesConnectionIdempotencyPolicyOption>(
        iam_v3::
            MakeDefaultPrincipalAccessBoundaryPoliciesConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace iam_v3_internal
}  // namespace cloud
}  // namespace google
